/*
 *
 *  Psych0Day
 *
 *     PDAY.C -- sloppy main source
 *
 *
 *  See the included README.xxx file.
 *
 *
 *  Short History
 *    97-10-26: v1.00 released [Andrew Ziem]
 *
 *
 *  Ideas
 *    - verbose switch
 *       "Today is Wednesday, July the 4th, 1997..."
 *    - "Mfull"  display if moon is full token for files (m15 = age of moon)
 *    - generate calendar
 *    - random date
 *    - BBS userbase converter
 *    - other program's data converter
 *    - execute whatever on a specific date
 *    - 'D' for death (hehe, sounds like a title)
 *    - deal with date uncertianties
 *
 *
 *  Problems and Concerns
 *    - most of `pdata.c' sucks, needs rewriting
 *       - 'C'ontinued and DOW not handled
 *           - concatenate Continued strings
 *       - '!' mishandled
 *
 *  Needs
 *    - astrological information, mainly positions of our sun and moon
 *
 *
 */

/* TurboC pragma, compile with small model */
#pragma -ms

/* #define _ALPHA */

#define INC_DATABASE
#define NO_JEWISH

#include "d:\c\pday\pday.h"
#include "d:\c\pday\pdata.c"


#define SHOWFMT "%-15s"
void
showdays()
{

/* not quite right, but... */
if (opts.showdiscord || opts.showfrench || opts.showgoddesslunar ||
    opts.showgregorian || opts.showjulian || opts.showilluminati ||
    opts.showthelemic || opts.showmoon)
    printf("\n");
/* oh well */

if (opts.showdiscord)
   {

    printf(SHOWFMT, "Discordian:");
    if (greg.yday==60 && greg.month==2)
     printf("St. Tib's Day, y.C. %i\n", greg.year+1166);
    else
    printf("%s, %s %i%s, y.C. %i\n",
     poeedays[poeedayweek(greg.yday)-1],                 /* day of week */
     poeeseasons[poeeseason(greg.yday, greg.year)],      /* season */
     poeedayseason(greg.yday, greg.year),                /* day of season */
     ordinal_text(poeedayseason(greg.yday, greg.year)),
     greg.year+1166);					 /* year */

     } /* Discordian */

 if (opts.showfrench)
   {
     int year, month, day;

     SdnToFrench(greg.JDN, &year, &month, &day);
     if (year!=0)
      {
        printf(SHOWFMT, "French Rep.:");
	printf("%s %i%s, %i\n",
	    FrenchMonthName[month],
	    day,
	    ordinal_text(day),
	    year);
	}
    } /* French Republican */

 if (opts.showgoddesslunar)
   {
     glcdate glc;

     printf(SHOWFMT, "Goddess Lunar:");
     glc.jdn=greg.JDN;
     jdn_to_goddess_date(&glc);
     printf("%s %d%s, %ld\n",
	    lunar_months[glc.month-1],
	    glc.day,
	    ordinal_text(glc.day),
	    glc.year);

    } /* Goddess Lunar */

 if (opts.showgregorian)

   {
     printf(SHOWFMT, "Gregorian:");
     printf("%s, %s %i%s, %s%i%s (day #%i, week #%i)\n",
       days[greg.wday],
       months[greg.month-1],
       greg.mday,
       ordinal_text(greg.mday),
       greg.year>0  ? "A.D. " : "",
/* ??      greg.year>0  ? greg.year : abs(greg.year-1), */
       abs(greg.year),
       greg.year<=0 ? " B.C." : "",
       greg.yday,
       weeknum(greg.year, greg.month, greg.mday));

      } /* Gregorian */


if (opts.showilluminati)
   {

    printf(SHOWFMT, "Illuminati:");
    if (greg.yday==60 && greg.month==2)
     printf("Heiligefliegendekindersheissetag, A.L. %i\n", greg.year+4000);
    else
    printf("%s %i%s, A.L. %i\n",
     illseasons[poeeseason(greg.yday, greg.year)],       /* season */
     poeedayseason(greg.yday, greg.year),                /* day of season */
     ordinal_text(poeedayseason(greg.yday, greg.year)),
     greg.year+4000);                                    /* year */

     } /* Illuminati */

#ifndef NO_JEWISH
/* locks up on conversion, not gonna worry 'bout it yet */
 if (opts.showjewish)
  {
    int day=1, month=1, year=3000;

    SdnToJewish(greg.JDN, &year, &month, &day);

    if (year>0)
    {
	    printf(SHOWFMT, "Hebrew:");

	    printf("%s %i%s, %i A.H.\n",
		    JewishMonthName[month],
		    day,
		    ordinal_text(day),
		    year);
	}

    }
#endif

 if (opts.showjulian)
  {
    int day, month, year;
    char sJDN[10];

    printf(SHOWFMT, "Julian:");
    SdnToJulian(greg.JDN, &year, &month, &day);
    commafmt(sJDN, 10, greg.JDN);
    printf("%s %i%s, %i (JDN %s)\n",
	   months[month-1],
	   day,
	   ordinal_text(day),
	   year,
	   sJDN);

   } /* Julian */

 if (opts.showmoon)
  {
    printf(SHOWFMT, "Moon:");
    printf("%s\n",MoonPhaseText[Moon_Phase(greg.year, greg.yday)]);

    } /* lunar */


 if (opts.showthelemic)
   {
     char yearbuf[10];

     if (greg.year>=1904) /* in range */
      {
        printf(SHOWFMT, "Thelemic:");
	printf("%s %i%s, Anno %s\n",
         months[greg.month-1],
         greg.mday,
         ordinal_text(greg.mday),
         long2roman(greg.year-1904, yearbuf, 10));
	 }
      } /* Thelemic */

 }

void
usage()
{

/* removed */
/*         "PTODAY [-dx] [-qx]\n\n" 
           "    d:        debug level\n" 
           "    q:        quietness level\n" */

#define USAGE "\nUsage:\n" \
	      "PDAY [{-|+}c[x]] [-Fdd[mm[yyyy]]] [-i] [{-|+}l] [-libdir=drive:\\dir\\]\n\n" \
	      "    c:        toggle display of calendars\n" \
	      "    f:        force date\n" \
	      "    i:        information\n" \
	      "    l:        toggle library support\n" \
	      "    libdir:   library directory\n" \
	      "\n"

 printf(USAGE);
 exit(1);

  }



int main(int argc, char *argv[])
{

#if defined(_ALPHA)
 char libdir[MAXDIR] = "c:\\os2\\apps\\today\\";
#else
 char libdir[MAXDIR] = ".\\";
#endif

 time_t t;	/* long same as time_t */
 struct tm *eris;

 int i;


 /* say hello */
 printf("\n" PROG_NAME " version " PROG_VER "\n");
 printf("Public Domain by Andrew Ziem.  Enjoy!\n");

 /* pardon my zinger, do you have the time? */
 tzset();
 t= time(NULL);
 eris=localtime(&t);
 greg.year=eris->tm_year+1900; /* int tm_year; Year (calendar year minus 1900) */
 greg.month=eris->tm_mon+1;    /* int tm_mon;  Month (0--11) */
 greg.mday=eris->tm_mday;      /* int tm_mday; Day of month (1--31) */
/* greg.wday=eris->tm_wday+1;     int tm_wday; Weekday (0--6; Sunday = 0) */

 for (i=1; i<argc; i++) {

   char *opt, ss[10];

   opt = argv[i];

   if (opt[0]=='/' || opt[0]=='-' || opt[0]=='+') { /* strlen(opt)>2 && */
	switch (toupper(opt[1])) {

	case 'C':
	  switch (toupper(opt[2])) {
	       case 'D': opts.showdiscord=(opt[0]=='+');
			 break;
	       case 'F': opts.showfrench=(opt[0]=='+');
			 break;
	       case 'G': opts.showgregorian=(opt[0]=='+');
			 break;
	       case 'I': opts.showilluminati=(opt[0]=='+');
			 break;
	       case 'J': opts.showjulian=(opt[0]=='+');
			 break;
	       case 'L': opts.showgoddesslunar=(opt[0]=='+');
			 break;
	       case 'M': opts.showmoon=(opt[0]=='+');
			 break;
	       case 'T': opts.showthelemic=(opt[0]=='+');
			 break;
#if defined(OS2)
/* OS/2 has a cow over this */
#else
		default: opts.showdiscord=opts.showfrench=opts.showgregorian=
			 opts.showilluminati=opts.showjulian=
			 opts.showgoddesslunar=opts.showmoon=
			 opts.showthelemic=(opt[0]=='+');
#endif
	       }
	     break;

	case 'L':
	  opt[7]=NUL;
	  if (strcmpi(opt+1,"libdir")==0)
	    strcpy(libdir,opt+8);
	    else
	    switch (toupper(opt[2])) {
	     case 'E': opts.showevents=(opt[0]=='+');
		       break;
	     case 'B': opts.showbirthdays=(opt[0]=='+');
		       break;
	     case 'R': opts.showreminders=(opt[0]=='+');
		       break;
#if defined(OS2)
           default: opts.showevents=(opt[0]=='+');
                    opts.showbirthdays=(opt[0]=='+');
                    opts.showreminders=(opt[0]=='+');
#else
	      default: opts.showevents=opts.showbirthdays=
		       opts.showreminders=(opt[0]=='+');
#endif
	     }
	  break;
	case 'F':

	  strncpy(ss, opt+2, 2);
	  ss[2]=NUL;
	  greg.mday = atoi(ss);

	  if (strlen(opt+2)>=4)
	   {

		strncpy(ss, opt+4, 2);
		ss[2]=NUL;
		greg.month = atoi(strncpy(ss, opt+4, 2));

		}

	  if(strlen(opt+2)>=7)
	  {
		strncpy(ss, opt+6, 7);
		ss[7]=NUL;
		greg.year = atoi(ss);
	   }

	  break;

	case 'I':

	  printf("\nCompiled on %s at %s.\n", __DATE__, __TIME__);
	  printf("Enviroment variable 'TZ' set to '%s'.\n",getenv("TZ"));

	  printf(CONTACT);

	  printf("\nPortions copyright 1993-1995, Scott E. Lee.\n");
	  printf("For further information, see the documentation file 'PDAY.DOC'.\n");

	  exit(EXIT_SUCCESS);

	default: usage();
	} /* switch */
   } /* if... */
   else usage();
 } /* for */

// printf("debug: opts.showbirthdays=%i\n", opts.showbirthdays);
// printf("debug: opts.showevents=%i\n", opts.showevents);
// printf("debug: opts.showreminders=%i\n", opts.showreminders);

 if (!valiDate_(greg.year, greg.month,greg.mday))
  criterr("\ninvalid date:\n day=%d\n month=%d\n year=%d", greg.mday, greg.month, greg.year);

 greg.yday=daynum(greg.year, greg.month, greg.mday);
 greg.wday=dow(greg.year, greg.month, greg.mday);
 greg.JDN=ymd_to_jdnl(greg.year, greg.month, greg.mday, 0);
#ifdef NOTUSED
 greg.JDN=GregorianToSdn(greg.year, greg.month, greg.mday);
 greg.JDN=JDN(greg.year, greg.month, greg.mday);
#endif

 showdays();

#if defined(INC_DATABASE)

 if (opts.showevents || opts.showbirthdays)
 {
  char s[MAXPATH], ss[10];
  DIRSTRUCT dirfile;

  int done;
  int trip=0;

  add_backslash(libdir);
  /* printf("debug: libdir='%s'\n", libdir); */

  pickextention:

  switch(trip)    {
   case 0:  strcpy(ss,"own");
	    break;
   case 1:  strcpy(ss,"all");
	    break;
   case 2:  strncpy(ss,months[greg.month-1],3);
	    ss[3]=NUL;
	    break;

     }

  strcpy(s,libdir);
  strcat(s,"*.");
  strcat(s,ss);

  done = findfirst(s, &dirfile, FINDATTR); /* *.<mmm> */
  while (!done)
  {
   strcpy(s,libdir);
   strcat(s, ffname(dirfile));
   searchdatabase(s);

   done = findnext(&dirfile);
   }

  ++trip;

  if (trip<3)
	goto pickextention;

#if defined(OS2)
  FIND_END(&dirfile);
#endif

  }

 if (opts.showbirthdays)
  dumpdata(T_BIRTHDAY);
 if (opts.showevents)
  dumpdata(T_EVENT);
/* if (opts.showreminders)
    dumpdata(T_REMINDER); */

#endif /* INC_DATABASE */

 printf("\nThat's all for TODAY.\n");

 return 0;
 }

/* End of file "PDAY.C" */
